move file installation from rules to dh_install files
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
42fi
43if [ $MSGLEVEL -le 3 ]; then
44 msginfo() { true; }
45 msgninfo() { true; }
46fi
47if [ $MSGLEVEL -le 4 ]; then
48 msgdebug() { true; }
49 msgndebug() { true; }
50fi
51msgdone() {
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
57 true;
58 else
59 echo "${CDONE}DONE${CNORMAL}" >&2;
60 fi
61}
8d876415
DK
62
63runapt() {
64 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
65 if [ -f ./aptconfig.conf ]; then
66 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
67 elif [ -f ../aptconfig.conf ]; then
68 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
69 else
70 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
71 fi
8d876415
DK
72}
73aptconfig() { runapt apt-config $*; }
74aptcache() { runapt apt-cache $*; }
75aptget() { runapt apt-get $*; }
76aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 77aptkey() { runapt apt-key $*; }
158fda31
DK
78dpkg() {
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
80}
b6b5a542
DK
81aptitude() {
82 if [ -f ./aptconfig.conf ]; then
83 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
84 elif [ -f ../aptconfig.conf ]; then
85 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
86 else
87 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 fi
89}
8d876415
DK
90
91setupenvironment() {
75954ae2 92 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 93 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 94 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 95 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
96 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
97 local OLDWORKINGDIRECTORY=$(pwd)
f213b6ea
DK
98 CURRENTTRAP="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
99 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
8d876415 100 cd $TMPWORKINGDIRECTORY
cd725954 101 mkdir rootdir aptarchive keys
8d876415 102 cd rootdir
b29c3712
DK
103 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
104 mkdir -p var/cache var/lib var/log
cffea9af 105 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 106 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
107 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
108 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
109 else
110 touch var/lib/dpkg/status
111 fi
cd725954 112 touch var/lib/dpkg/available
8d876415
DK
113 mkdir -p usr/lib/apt
114 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
115 cd ..
2c6baa5a 116 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
117 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
118 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 119 fi
4a4ea26c
AM
120 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
121 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
122 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
4a4ea26c 123 fi
cd725954
DK
124 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
125 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 126 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 127 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
128 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
129 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 130 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
131 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
132 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
133 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
134 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
135 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
136 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 137 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
138 export LC_ALL=C
139 msgdone "info"
140}
141
142configarchitecture() {
143 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
144 echo "APT::Architecture \"$1\";" > $CONFFILE
145 shift
146 while [ -n "$1" ]; do
147 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
148 shift
149 done
150}
151
75954ae2 152setupsimplenativepackage() {
ce9864a8
DK
153 local NAME="$1"
154 local ARCH="$2"
155 local VERSION="$3"
156 local RELEASE="${4:-unstable}"
157 local DEPENDENCIES="$5"
158 local DESCRIPTION="$6"
b7899b00
DK
159 local SECTION="${7:-others}"
160 local DISTSECTION
161 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
162 DISTSECTION="main"
163 else
164 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
165 fi
ce9864a8
DK
166 local BUILDDIR=incoming/${NAME}-${VERSION}
167 mkdir -p ${BUILDDIR}/debian/source
168 cd ${BUILDDIR}
169 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
170 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
171 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
172
173 * Initial release
174
b7899b00
DK
175 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
176 test -e debian/control || echo "Source: $NAME
177Section: $SECTION
ce9864a8
DK
178Priority: optional
179Maintainer: Joe Sixpack <joe@example.org>
180Build-Depends: debhelper (>= 7)
181Standards-Version: 3.9.1
182
183Package: $NAME
b7899b00 184Architecture: $ARCH" > debian/control
ce9864a8
DK
185 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
186 if [ -z "$DESCRIPTION" ]; then
187 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
188 If you find such a package installed on your system,
189 YOU did something horribly wrong! They are autogenerated
190 und used only by testcases for APT and surf no other propose…" >> debian/control
191 else
192 echo "Description: $DESCRIPTION" >> debian/control
193 fi
b7899b00
DK
194 test -e debian/compat || echo "7" > debian/compat
195 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 196 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
197 cd - > /dev/null
198}
199
200buildsimplenativepackage() {
201 local NAME="$1"
202 local ARCH="$2"
203 local VERSION="$3"
204 local RELEASE="${4:-unstable}"
205 local DEPENDENCIES="$5"
206 local DESCRIPTION="$6"
207 local SECTION="${7:-others}"
208 local DISTSECTION
209 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
210 DISTSECTION="main"
211 else
212 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
213 fi
214 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
215 buildpackage "incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
216 rm -rf "incoming/${NAME}-${VERSION}"
217}
218
219buildpackage() {
220 local BUILDDIR=$1
221 local RELEASE=$2
222 local SECTION=$3
223 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
224 cd $BUILDDIR
225 if [ "$ARCH" = "all" ]; then
226 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
227 fi
b7899b00
DK
228 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
229 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 230 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 231 cd - > /dev/null
b7899b00 232 for PKG in $PKGS; do
75954ae2 233 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
234 done
235 for SRC in $SRCS; do
75954ae2 236 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 237 done
cffea9af 238 msgdone "info"
ce9864a8
DK
239}
240
241buildaptarchive() {
ce9864a8
DK
242 if [ -d incoming ]; then
243 buildaptarchivefromincoming $*
244 else
245 buildaptarchivefromfiles $*
246 fi
247}
248
249createaptftparchiveconfig() {
250 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
251 if [ -z "$ARCHS" ]; then
252 # the pool is empty, so we will operate on faked packages - let us use the configured archs
253 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
254 fi
ce9864a8
DK
255 echo -n 'Dir {
256 ArchiveDir "' >> ftparchive.conf
257 echo -n $(readlink -f .) >> ftparchive.conf
258 echo -n '";
259 CacheDir "' >> ftparchive.conf
260 echo -n $(readlink -f ..) >> ftparchive.conf
261 echo -n '";
b7899b00
DK
262 FileListDir "' >> ftparchive.conf
263 echo -n $(readlink -f pool/) >> ftparchive.conf
264 echo -n '";
265};
266Default {
267 Packages::Compress ". gzip bzip2 lzma";
268 Sources::Compress ". gzip bzip2 lzma";
269 Contents::Compress ". gzip bzip2 lzma";
ce9864a8
DK
270};
271TreeDefault {
272 Directory "pool/";
273 SrcDirectory "pool/";
274};
275APT {
276 FTPArchive {
277 Release {
278 Origin "joesixpack";
279 Label "apttestcases";
280 Suite "unstable";
281 Description "repository with dummy packages";
282 Architectures "' >> ftparchive.conf
283 echo -n "$ARCHS" >> ftparchive.conf
284 echo 'source";
285 };
286 };
287};' >> ftparchive.conf
b7899b00
DK
288 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
289 echo -n 'tree "dists/' >> ftparchive.conf
290 echo -n "$DIST" >> ftparchive.conf
291 echo -n '" {
ce9864a8
DK
292 Architectures "' >> ftparchive.conf
293 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
294 echo -n 'source";
295 FileList "' >> ftparchive.conf
296 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
297 echo -n '";
298 SourceFileList "' >> ftparchive.conf
299 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
300 echo -n '";
301 Sections "' >> ftparchive.conf
302 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
303 echo '";
ce9864a8 304};' >> ftparchive.conf
b7899b00 305 done
ce9864a8
DK
306}
307
308buildaptftparchivedirectorystructure() {
b7899b00
DK
309 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
310 for DIST in $DISTS; do
311 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
312 for SECTION in $SECTIONS; do
313 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
314 for ARCH in $ARCHS; do
315 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
316 done
317 mkdir -p dists/${DIST}/${SECTION}/source
318 mkdir -p dists/${DIST}/${SECTION}/i18n
319 done
ce9864a8 320 done
ce9864a8
DK
321}
322
9b78cda6
DK
323insertpackage() {
324 local RELEASE="$1"
325 local NAME="$2"
326 local ARCH="$3"
327 local VERSION="$4"
328 local DEPENDENCIES="$5"
329 local ARCHS="$ARCH"
330 if [ "$ARCHS" = "all" ]; then
331 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
332 fi
333 for BUILDARCH in $ARCHS; do
334 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
335 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
336 touch aptarchive/dists/${RELEASE}/main/source/Sources
337 local FILE="${PPATH}/Packages"
338 echo "Package: $NAME
339Priority: optional
340Section: other
2c085486 341Installed-Size: 42
9b78cda6
DK
342Maintainer: Joe Sixpack <joe@example.org>
343Architecture: $ARCH
2c085486
DK
344Version: $VERSION
345Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
9b78cda6
DK
346 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
347 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
348 If you find such a package installed on your system,
349 YOU did something horribly wrong! They are autogenerated
350 und used only by testcases for APT and surf no other propose…
351" >> $FILE
352 done
353}
354
ce9864a8 355buildaptarchivefromincoming() {
3cbbda3c 356 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
357 cd aptarchive
358 [ -e pool ] || ln -s ../incoming pool
359 [ -e ftparchive.conf ] || createaptftparchiveconfig
360 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 361 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 362 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
363 cd - > /dev/null
364 msgdone "info"
9b78cda6 365 generatereleasefiles
ce9864a8
DK
366}
367
368buildaptarchivefromfiles() {
3cbbda3c 369 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
370 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
371 msgninfo "\t${line} file… "
372 cat ${line} | gzip > ${line}.gz
373 cat ${line} | bzip2 > ${line}.bz2
374 cat ${line} | lzma > ${line}.lzma
8d876415 375 msgdone "info"
9b78cda6
DK
376 done
377 generatereleasefiles
378}
379
380generatereleasefiles() {
381 msgninfo "\tGenerate Release files… "
382 if [ -e aptarchive/dists ]; then
383 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 384 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
385 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
386 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
387 sed -i '/^Date: / a\
388NotAutomatic: yes' $dir/Release
389 fi
9b78cda6
DK
390 done
391 else
392 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 393 fi
b7899b00 394 msgdone "info"
8d876415
DK
395}
396
b7899b00
DK
397setupdistsaptarchive() {
398 local APTARCHIVE=$(readlink -f ./aptarchive)
399 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
400 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
401 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
402 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
403 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
404 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
405 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
406 msgdone "info"
407 done
408}
409
410setupflataptarchive() {
ce9864a8 411 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
412 if [ -f ${APTARCHIVE}/Packages ]; then
413 msgninfo "\tadd deb sources.list line… "
414 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
415 msgdone "info"
416 else
417 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
418 fi
419 if [ -f ${APTARCHIVE}/Sources ]; then
420 msgninfo "\tadd deb-src sources.list line… "
421 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
422 msgdone "info"
423 else
424 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
425 fi
b7899b00
DK
426}
427
428setupaptarchive() {
429 buildaptarchive
430 if [ -e aptarchive/dists ]; then
431 setupdistsaptarchive
432 else
433 setupflataptarchive
434 fi
f213b6ea 435 signreleasefiles
cd725954 436 msgninfo "\tSync APT's cache with the archive… "
8d876415 437 aptget update -qq
cd725954 438 msgdone "info"
8d876415
DK
439}
440
f213b6ea
DK
441signreleasefiles() {
442 local SIGNER="${1:-Joe Sixpack}"
443 msgninfo "\tSign archive with $SIGNER key… "
444 local SECKEYS=""
445 for KEY in $(find keys/ -name '*.sec'); do
446 SECKEYS="$SECKEYS --secret-keyring $KEY"
447 done
448 local PUBKEYS=""
449 for KEY in $(find keys/ -name '*.pub'); do
450 PUBKEYS="$PUBKEYS --keyring $KEY"
451 done
452 for RELEASE in $(find aptarchive/ -name Release); do
453 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
454 done
455 msgdone "info"
456}
457
458changetowebserver() {
459 if which weborf > /dev/null; then
460 weborf -xb aptarchive/ 2>&1 > /dev/null &
0dc05bf0 461 CURRENTTRAP="kill $!; $CURRENTTRAP"
f213b6ea
DK
462 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
463 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
464 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
465 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
466 done
467 return 0
468 fi
469 return 1
470}
471
472checkdiff() {
8d876415
DK
473 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
474 if [ -n "$DIFFTEXT" ]; then
475 echo
476 echo "$DIFFTEXT"
477 return 1
478 else
479 return 0
480 fi
481}
482
75954ae2
DK
483testfileequal() {
484 local FILE="$1"
485 shift
486 msgtest "Test for correctness of file" "$FILE"
487 if [ -z "$*" ]; then
f213b6ea 488 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 489 else
f213b6ea 490 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
491 fi
492}
493
8d876415
DK
494testequal() {
495 local COMPAREFILE=$(mktemp)
496 echo "$1" > $COMPAREFILE
497 shift
498 msgtest "Test for equality of" "$*"
f213b6ea 499 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8e86786b 500 rm $COMPAREFILE
8d876415
DK
501}
502
685625bd
DK
503testequalor2() {
504 local COMPAREFILE1=$(mktemp)
505 local COMPAREFILE2=$(mktemp)
506 local COMPAREAGAINST=$(mktemp)
507 echo "$1" > $COMPAREFILE1
508 echo "$2" > $COMPAREFILE2
509 shift 2
510 msgtest "Test for equality OR of" "$*"
511 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
512 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
513 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
514 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
515 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd 516 msgfail )
8e86786b 517 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
685625bd
DK
518}
519
8d876415 520testshowvirtual() {
4bec02c2 521 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
522 local PACKAGE="$1"
523 shift
524 while [ -n "$1" ]; do
525 VIRTUAL="${VIRTUAL}
4bec02c2 526N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
527 PACKAGE="${PACKAGE} $1"
528 shift
529 done
530 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
531 VIRTUAL="${VIRTUAL}
4bec02c2 532N: No packages found"
8d876415
DK
533 local COMPAREFILE=$(mktemp)
534 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
535 eval `apt-config shell ARCH APT::Architecture`
536 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 537 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8e86786b 538 rm $COMPAREFILE
8d876415
DK
539}
540
541testnopackage() {
542 msgtest "Test for non-existent packages" "apt-cache show $*"
543 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
544 if [ -n "$SHOWPKG" ]; then
545 echo
546 echo "$SHOWPKG"
547 msgfail
548 return 1
549 fi
550 msgpass
551}
01a6e24c
DK
552
553testdpkginstalled() {
554 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
555 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
556 if [ "$PKGS" != 0 ]; then
557 echo $PKGS
558 dpkg -l $* | grep '^[a-z]'
559 msgfail
560 return 1
561 fi
562 msgpass
563}
564
565testdpkgnoninstalled() {
566 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
567 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
568 if [ "$PKGS" != 0 ]; then
569 echo
570 dpkg -l $* | grep '^[a-z]'
571 msgfail
572 return 1
573 fi
574 msgpass
575}